#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "bmslsort.h"


enum {
  BUF_SIZE = 1024,
};

// Ō̉sR[h菜
static bool chomp( char *str );


// BMS\͊֐
BmsBms *read_bms( char *file_name ) {
  char buf[BUF_SIZE];
  BmsBms *bms = new BmsBms();

  int ch01_count[BMS_BAR_MAX];
  for ( int i = 0; i < BMS_BAR_MAX; ++i ) {
    ch01_count[i] = 0;
  }

  FILE *in_file = fopen( file_name, "r" );
  if ( in_file == NULL ) { goto ERR; }

  // ߒύXɓǂݍ
  while ( fgets( buf, BUF_SIZE, in_file ) != NULL ) {
    chomp( buf );
    int i = 0;
    // s̋󔒂͖Ĉړ
    while ( buf[i] == ' ' ) { ++i; }
    // 擪#ł͖Ζ
    if ( buf[i] != '#' ) { continue; }

    // #ȍ~Ɉړ
    ++i;

    // ł͂ȂΖ
    if ( isdigit( buf[i] ) == 0 ) { continue; }

    // ߔԍ擾
    char bar_num_str[4];
    strncpy( bar_num_str, &buf[i], 3 );
    bar_num_str[3] = '\0';
    int bar_num = atoi( bar_num_str );

    // `lԍ擾
    BmsWord channel_num( &buf[i + 3] );
    // "02" ȊO͖
    if ( channel_num != "02" ) { continue; }
    // f[^擾
    char *data = &buf[i + 6];

    BmsBar current_bar = bms->bar_at( bar_num );
    if ( current_bar.get_length_int() != BAR_LENGTH_DEFAULT  ) { goto ERR; }
    // ߒo^
    current_bar.set( data );
    bms->overwrite_bar_at( bar_num, current_bar );
  }

  // ߂Ēʏ̉
  rewind( in_file );
  while ( fgets( buf, BUF_SIZE, in_file ) != NULL ) {
    chomp( buf );

    int i = 0;
    // s̋󔒂͖Ĉړ
    while ( buf[i] == ' ' ) { ++i; }

    // 擪#ł͖Ζ
    if ( buf[i] != '#' ) { continue; }

    // #ȍ~Ɉړ
    ++i;

    // pł͂ȂΖ
    if ( isalnum( buf[i] ) == 0 ) { continue; }

    // wb_
    if ( isalpha( buf[i] ) ) {
      // wb_擾
      char *header_begin = &buf[i];

      // 󔒕܂Ői߂ċ󔒕Ȃ炻'\0'
      for ( ; buf[i] != ' ' && buf[i] != '\t'; ++i ) { }
      buf[i] = '\0';

      // 󔒕I܂Ői߂ďI炻valuëʒu
      ++i;
      for ( ; buf[i] == ' ' || buf[i] == '\t'; ++i ) { }
      char *value_begin = &buf[i];

      // WAVo^
      if ( bms->get_wavs()->check_structer( header_begin ) ) {
        header_begin += 3;
        if ( bms->get_wavs()->overwrite( header_begin, value_begin ) ){ printf( "wavs overwrite\n"); }
      }
      // BMPo^
      else if ( bms->get_bmps()->check_structer( header_begin ) ) {
        header_begin += 3;
        if ( bms->get_bmps()->overwrite( header_begin, value_begin ) ){ printf( "wavs overwrite\n"); }
      }
      // ʏwb_o^
      else{
        bms->get_headers()->store( header_begin, value_begin );
      }
    }
    // ߏf[^
    else {
      // ߔԍ擾
      char bar_num_str[4];
      strncpy( bar_num_str, &buf[i], 3 );
      bar_num_str[3] = '\0';
      int bar_num = atoi( bar_num_str );

      // `lԍ擾
      BmsWord channel_num( &buf[i + 3] );
      // "02" = ߒύX͍ŏɕύXĂ̂ō͖
      if ( channel_num == "02" ) { continue; }
      // f[^񕔎擾
      char *data = &buf[i + 6];

      // `lԍ"01"͏dȂ̂œȏ
      if ( channel_num == "01" ) {
        // o^Jnʒu擾
        int to = bms->get_channel_position( bar_num );
        // ̏߂̒
        int length = bms->bar_at( bar_num ).get_length_int();

        // BMS\`FbN
        int n = strlen( data );
        if ( n == 0 || ( n % 2 ) == 1 || ( n / 2 ) > length ) { goto ERR; }
        
        BmsChannel *temp_channel = bms->get_channel( channel_num );
        BmsChannel *prev_channel = NULL_CHANNEL;
        for ( int i = 0; i < ch01_count[bar_num]; ++i ) {
          prev_channel = temp_channel;
          temp_channel = temp_channel->get_same_next();
        }
        ++ch01_count[bar_num];
        
        // `lIuWFNg΍ēo^
        if ( temp_channel == NULL_CHANNEL ) {
          temp_channel = new BmsChannel( channel_num );
          if ( prev_channel == NULL_CHANNEL ) { bms->set_channel( temp_channel ); }
          else { prev_channel->set_same_next( temp_channel ); }
        }

        // IuWF͂ēo^
        int str_position = 0;
        int step = length / ( n / 2 );
        for ( int i = to; i < to + length; i += step ) {
          temp_channel->overwrite( i, BmsObject( &data[str_position] ) );
          str_position += 2;
        }
      }
      else {
        // ʂɓo^
        bms->input_str( bar_num, channel_num, data );
      }
    }
  }
  // ͏I
  fclose( in_file );

  return bms;


ERR:
  if ( bms != NULL ) { delete bms; }
  fclose( in_file );
  return NULL_BMS;
}



// BMSo͊֐
bool write_bms( char *file_name ) {
  // o͊Jn
  char buf[BUF_SIZE];
  char word_buf[3];
  char header[BUF_SIZE];
  char value[BUF_SIZE];

  FILE *out_file = fopen( file_name, "w" );
  if ( out_file == NULL ) { return false; }

  BmsHeaderHash *header_hash = bms->get_headers()->clone();
  
  // wb_o
  if ( header_hash->take_str( LABEL_TITLE_STR, value ) ) {
    fprintf( out_file, "#%s %s\n", LABEL_TITLE_STR, value );
  }
  if ( header_hash->take_str( LABEL_GENRE_STR, value ) ) {
    fprintf( out_file, "#%s %s\n", LABEL_GENRE_STR, value );
  }
  if ( header_hash->take_str( LABEL_ARTIST_STR, value ) ) {
    fprintf( out_file, "#%s %s\n", LABEL_ARTIST_STR, value );
  }
  while ( header_hash->shift( header, value ) ) {
    fprintf( out_file, "#%s %s\n", header, value );
  }
  delete header_hash;
  fprintf( out_file, "\n" );

  BmsWord nth;
  // WAVo
  BmsRegistArray *wavs = bms->get_wavs()->clone();
  while ( wavs->shift( &nth, value ) ) {
    fprintf( out_file, "#%s%s %s\n", wavs->get_name(), nth.get_str_null( header ), value );
  }
  delete wavs;
  fprintf( out_file, "\n" );
  // BMPo
  BmsRegistArray *bmps = bms->get_bmps()->clone();
  while ( bmps->shift( &nth, value ) ) {
    fprintf( out_file, "#%s%s %s\n", bmps->get_name(), nth.get_str_null( header ), value );
  }
  delete bmps;
  fprintf( out_file, "\n" );

  // ߃f[^o
  // IuWF݂鏬߂܂ŏo
  int max_bar = bms->get_max_bar();
  for ( int i = 0; i <= max_bar; ++i ) {
    BmsBar current_bar = bms->bar_at( i );
    // ߒύXo
    if ( current_bar.get_length_int() != BAR_LENGTH_DEFAULT ) {
      fprintf( out_file, "#%03d%s:%f\n", i, "02", current_bar.get_length_double() );
    }

    // f[^o
    for ( BmsChannel *temp_channel = bms->get_first_channel(); temp_channel != NULL_CHANNEL; temp_channel = temp_channel->get_next() ) {
      // `lԍ"01"͏dȂ̂œȏ
      if ( temp_channel->get_channel_number() == "01" ) {
        for ( BmsChannel *temp_channel_same = temp_channel; temp_channel_same != NULL_CHANNEL; temp_channel_same = temp_channel_same->get_same_next() ) {
          int to = bms->get_channel_position( i );
          int length = current_bar.get_length_int();

          // ͈͓ɃIuWFĂo͂
          // ΂ԊuvZ
          int step = length;
          for ( int k = 1; k < length; ++k ) {
            if ( temp_channel_same->at( to + k ) != "00" ) {
              step = BmsUtil::gcd( step, k );
            }
          }

          // obt@ɓĂ
          int str_position = 0;
          for ( int k = to; k < to + length; k += step ) {
            temp_channel_same->at( k ).get_str( &buf[str_position] );
            str_position += 2;
          }
          buf[str_position] = '\0';
          fprintf( out_file, "#%03d%s:%s\n",
                  i,
                  temp_channel_same->get_channel_number().get_str_null( word_buf ),
                  buf );
        }
      }
      else {
        // ʂɏo
        int str_len = bms->to_str_null( i, temp_channel->get_channel_number(), buf ) ;
        if ( str_len > 2 || ( str_len == 2 && BmsObject( buf ) != "00" ) ) {
          fprintf( out_file, "#%03d%s:%s\n",
                  i,
                  temp_channel->get_channel_number().get_str_null( word_buf ),
                  buf );
        }
      }
    }
    fprintf( out_file, "\n" );
  }
  fclose( out_file );
  return true;
}



// Ō̉sR[h菜
static bool chomp( char *str ) {
  bool return_value = false;

  int i = strlen( str );
  if ( str[i - 1] == '\n' ) {
    str[i - 1] = '\0';
    return_value = true;
  }
  return return_value;
}
