#include <windows.h>
#include <commctrl.h>
#include <string.h>
#include <memory.h>

#include "bmslsort.h"

// Xg̃vV[W̔h֐
static LRESULT CALLBACK list_wind_proc( HWND h_wnd, UINT msg, WPARAM wp, LPARAM lp );
// Xg̔hO̊֐
static WNDPROC list_wind_proc_super;

// Xg̈ړ
bool move_list( HWND h_wnd, BmsRegistArray *list, bool up, void (*move_list_func)( int, int, bool ) );

// bmsRg[e
static void input_control_content( void );

// Jt@C擾
static bool get_open_filename( HWND h_wnd );
// ۑt@C擾
static bool get_save_filename( HWND h_wnd );
// init@Cɐݒۑ
static bool save_ini( HWND h_wnd );

static void repaint_list( HWND h_wnd, int i, const char *str ) {
  char buf[MAX_PATH];
  BmsWord( i ).get_str( buf );
  buf[2] = ':';
  strcpy( &buf[3], str );
  SendMessage( h_wnd, LB_DELETESTRING, i, 0 );
  SendMessage( h_wnd, LB_INSERTSTRING, i, (LPARAM)buf );
}

// Rg[Qϐ
static HWND group_background;
static HWND group;
static HWND label_title;
static HWND edit_title;
static HWND label_genre;
static HWND edit_genre;
static HWND label_artist;
static HWND edit_artist;
static HWND h_tab;
static BothList lists[LIST_COUNT];
// ݕ\Ă郊Xg{bNX
#define current_list lists[TabCtrl_GetCurSel( h_tab )]

// CEBhẼvV[W
LRESULT CALLBACK main_wind_proc( HWND h_wnd, UINT msg, WPARAM wp, LPARAM lp ) {

  switch ( msg ) {
  case WM_DESTROY: // EBhE
    save_ini( h_wnd );
    PostQuitMessage(0);
    return 0;

  case WM_DROPFILES: // t@CD&D
    HDROP h_drop;
    h_drop = (HDROP)wp;
    DragQueryFile( h_drop, 0, bms_path, sizeof(bms_path) );
    delete bms;
    bms = read_bms( bms_path );
    lists[0].bms = bms->get_wavs();
    lists[1].bms = bms->get_bmps();
    set_bms_path_dir( bms_path, true, true );
    set_window_title( h_wnd );
    input_control_content();
    DragFinish( h_drop );
    SetForegroundWindow( h_wnd );
    return 0;

  case WM_COMMAND:
    switch ( LOWORD( wp ) ) {
    case IDM_NEW: // j[ - VK쐬
      delete bms;
      bms = new BmsBms();
      set_bms_path_dir( "", false, false );
      set_window_title( h_wnd );
      input_control_content();
      return 0;

    case IDM_OPEN: // j[ - J
      if ( get_open_filename( h_wnd ) ) {
        delete bms;
        bms = read_bms( bms_path );
        lists[0].bms = bms->get_wavs();
        lists[1].bms = bms->get_bmps();
        set_bms_path_dir( bms_path, true, true );
        set_window_title( h_wnd );
        input_control_content();
      }
      return 0;

    case IDM_SAVE_AS:
      if ( !get_save_filename( h_wnd ) ) { return 0; }
      // returnȂ
    case IDM_SAVE:
      if ( bms_path[0] == '\0' && !get_save_filename( h_wnd ) ) { return 0; }
      write_bms( bms_path );
      return 0;

    case IDM_END: // j[ - I
      SendMessage( h_wnd, WM_DESTROY, 0, 0 );
      return 0;

    case IDM_HOW_TO_USE: // j[ - g
      MessageBox( h_wnd, "ꏏɂeLXgt@C݂", "g", MB_ICONINFORMATION );
      return 0;

    case IDM_VERSION: // j[ - o[W
      MessageBox( h_wnd, APP_NAME " - Version " APP_VERSION, "o[W", MB_ICONINFORMATION );
      return 0;

    case IDM_EXCHANGE: // I𒆂̏2
      for ( int i = 1; i < BMS_OBJ_MAX; ++i ) {
        if ( SendMessage( current_list.h_wnd, LB_GETSEL, i, 0 ) ) {
          for ( int k = i + 1; k < BMS_OBJ_MAX; ++k ) {
            if ( SendMessage( current_list.h_wnd, LB_GETSEL, k, 0 ) ) {
              if ( current_list.h_wnd == lists[0].h_wnd ) { exchange_bms_list_wav( i, k ); }
              else                                        { exchange_bms_list_bmp( i, k ); }
              repaint_list( current_list.h_wnd, i, current_list.bms->at( BmsWord( i ) ) );
              repaint_list( current_list.h_wnd, k, current_list.bms->at( BmsWord( k ) ) );
              break;
            }
          }
          break;
        }
      }
      return 0;

    case IDM_NOUSE_WAV:
      {
        bool exist[BMS_OBJ_MAX];
        get_exist_list_wav( exist );
        for ( int i = 1; i < BMS_OBJ_MAX; ++i ) {
          if ( !(exist[i]) && lists[0].bms->is_exist( BmsWord( i ) ) ) {
            lists[0].bms->delete_at( BmsWord( i ) );
            repaint_list( lists[0].h_wnd, i, "" );
          }
        }
      }
      return 0;

    case IDM_NOUSE_BMP:
      {
        bool exist[BMS_OBJ_MAX];
        get_exist_list_bmp( exist );
        for ( int i = 1; i < BMS_OBJ_MAX; ++i ) {
          if ( !(exist[i]) && lists[1].bms->is_exist( BmsWord( i ) ) ) {
            lists[1].bms->delete_at( BmsWord( i ) );
            repaint_list( lists[1].h_wnd, i, "" );
          }
        }
      }

      return 0;

    case IDM_FILL_WAV:
      {
        if ( MessageBox( h_wnd, "݂̋@\͎Ԃ|ꍇ܂BłH", "", MB_YESNO ) == IDNO ) { return 0; }
        HCURSOR h_cursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
        for ( int i = 1; i < BMS_OBJ_MAX; ++i ) {
          if ( lists[0].bms->is_empty( BmsWord( i ) ) ) {
            for ( int p = i;i < BMS_OBJ_MAX; ++i ) {
              if ( lists[0].bms->is_exist( BmsWord( i ) ) ) {
                exchange_bms_list_wav( p, i );
                repaint_list( lists[0].h_wnd, p, lists[0].bms->at( BmsWord( p ) ) );
                repaint_list( lists[0].h_wnd, i, lists[0].bms->at( BmsWord( i ) ) );
                ++p;
              }
            }
          }
        }
        SetCursor( h_cursor );
        return 0;
      }
    case IDM_FILL_BMP:
      {
        if ( MessageBox( h_wnd, "݂̋@\͎Ԃ|ꍇ܂BłH", "", MB_YESNO ) == IDNO ) { return 0; }
        HCURSOR h_cursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
        for ( int i = 1; i < BMS_OBJ_MAX; ++i ) {
          if ( lists[1].bms->is_empty( BmsWord( i ) ) ) {
            for ( int p = i;i < BMS_OBJ_MAX; ++i ) {
              if ( lists[1].bms->is_exist( BmsWord( i ) ) ) {
                exchange_bms_list_bmp( p, i );
                repaint_list( lists[1].h_wnd, p, lists[1].bms->at( BmsWord( p ) ) );
                repaint_list( lists[1].h_wnd, i, lists[1].bms->at( BmsWord( i ) ) );
                ++p;
              }
            }
          }
        }
        SetCursor( h_cursor );
        return 0;
      }
    }
    switch ( HIWORD( wp ) ) {
    case LBN_DBLCLK:
      return 0;
    }
    return 0;

  case WM_NOTIFY:
    switch ( ( (NMHDR *)lp )->code ) {
    case TCN_SELCHANGE: // ^uύX
      for ( int i = 0; i < LIST_COUNT; ++i ) {
        ShowWindow( lists[i].h_wnd, SW_HIDE );
      }
      ShowWindow( current_list.h_wnd, SW_SHOW );
      return 0;
    }
    return 0;

  case WM_SIZE: // EBhETCYύX
    MoveWindow( group_background, 0, 0, HEADER_WIDTH, ( (lp >> 16) & 0xFFFF ), TRUE );
    MoveWindow( group,            0, 0, GROUP_WIDTH,  ( (lp >> 16) & 0xFFFF ), TRUE );
    MoveWindow( h_tab, TAB_X, 0, LOWORD(lp) - TAB_X, ( (lp >> 16) & 0xFFFF ), TRUE );
    for ( int i = 0; i < LIST_COUNT; ++i ) {
      MoveWindow( lists[i].h_wnd, TAB_X + TAB_PADDING_LEFT, TAB_PADDING_TOP, LOWORD(lp) - TAB_X - TAB_PADDING_RIGHT, ( (lp >> 16) & 0xFFFF ) - TAB_PADDING_BOTTOM, TRUE );
    }
    return 0;

  case WM_CREATE: // EBhE
    // O[v{bNX쐬
    group_background = CreateWindowEx(
      0, "STATIC", NULL,
      WS_CHILD | WS_VISIBLE,
      0, 0, 0, 0,
      h_wnd, NULL,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    group = CreateWindowEx(
      0, "BUTTON", GROUP_STR,
      WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
      0, 0, 0, 0,
      h_wnd, NULL,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );

    int point_y;
    // wb_ - ^Cg
    point_y = GROUP_PADDING_TOP;
    label_title = CreateWindowEx(
      0, "STATIC", LABEL_TITLE_STR,
      WS_CHILD | WS_VISIBLE,
      GROUP_PADDING_LEFT, point_y, GROUP_WIDTH - GROUP_PADDING_RIGHT, LABEL_HEIGHT,
      group, (HMENU)ID_LABEL_TITLE,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    point_y += LABEL_HEIGHT;
    edit_title = CreateWindowEx(
      WS_EX_CLIENTEDGE, "STATIC", NULL,
      WS_CHILD | WS_VISIBLE | ES_LEFT,
      GROUP_PADDING_LEFT, point_y, GROUP_WIDTH - GROUP_PADDING_RIGHT, EDIT_HEIGHT,
      group, (HMENU)ID_EDIT_TITLE,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );

    // wb_ - W
    point_y += EDIT_HEIGHT + GROUP_BETWEEN;
    label_genre = CreateWindowEx(
      0, "STATIC", LABEL_GENRE_STR,
      WS_CHILD | WS_VISIBLE,
      GROUP_PADDING_LEFT, point_y, GROUP_WIDTH - GROUP_PADDING_RIGHT, LABEL_HEIGHT,
      group, (HMENU)ID_LABEL_GENRE,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    point_y += LABEL_HEIGHT;
    edit_genre = CreateWindowEx(
      WS_EX_CLIENTEDGE, "STATIC", NULL,
      WS_CHILD | WS_VISIBLE | ES_LEFT,
      GROUP_PADDING_LEFT, point_y, GROUP_WIDTH - GROUP_PADDING_RIGHT, EDIT_HEIGHT,
      group, (HMENU)ID_EDIT_GENRE,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );

    // wb_ - A[eBXg
    point_y += EDIT_HEIGHT + GROUP_BETWEEN;
    label_artist = CreateWindowEx(
      0, "STATIC", LABEL_ARTIST_STR,
      WS_CHILD | WS_VISIBLE,
      GROUP_PADDING_LEFT, point_y, GROUP_WIDTH - GROUP_PADDING_RIGHT, LABEL_HEIGHT,
      group, (HMENU)ID_LABEL_ARTIST,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    point_y += LABEL_HEIGHT;
    edit_artist = CreateWindowEx(
      WS_EX_CLIENTEDGE, "STATIC", NULL,
      WS_CHILD | WS_VISIBLE | ES_LEFT,
      GROUP_PADDING_LEFT, point_y, GROUP_WIDTH - GROUP_PADDING_RIGHT, EDIT_HEIGHT,
      group, (HMENU)ID_EDIT_ARTIST,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );

    // ^uRg[
    InitCommonControls();
    h_tab = CreateWindowEx(
      0, WC_TABCONTROL, NULL,
      WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE | WS_CLIPCHILDREN,
      0, 0, 0, 0,
      h_wnd, (HMENU)ID_TAB,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    TCITEM tc_item;
    tc_item.mask = TCIF_TEXT;
    tc_item.pszText = "WAV";
    TabCtrl_InsertItem(h_tab , 0 , &tc_item);
    tc_item.pszText = "BMP";
    TabCtrl_InsertItem(h_tab , 1 , &tc_item);

    // XgRg[ - WAV
    lists[0].h_wnd = CreateWindowEx(
      WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES, "LISTBOX", NULL,
      WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_NOTIFY | LBS_NOINTEGRALHEIGHT | LBS_DISABLENOSCROLL | LBS_NOINTEGRALHEIGHT | LBS_EXTENDEDSEL,
      0, 0, 0, 0,
      h_wnd, (HMENU)ID_LIST_WAV,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    // XgRg[ - BMP
    lists[1].h_wnd = CreateWindowEx(
      WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES, "LISTBOX", NULL,
      WS_CHILD | WS_VSCROLL | LBS_NOTIFY | LBS_NOINTEGRALHEIGHT | LBS_DISABLENOSCROLL | LBS_NOINTEGRALHEIGHT | LBS_EXTENDEDSEL,
      0, 0, 0, 0,
      h_wnd, (HMENU)ID_LIST_BMP,
      ( (LPCREATESTRUCT)lp )->hInstance, NULL
      );
    // hvV[WɕύX
    list_wind_proc_super = (WNDPROC)GetWindowLong( lists[0].h_wnd, GWL_WNDPROC );
    for ( int i = 0; i < LIST_COUNT; ++i ) {
      SetWindowLong( lists[i].h_wnd, GWL_WNDPROC, (LONG)( list_wind_proc ) );
      // ^uɕ\悤ɂ
      SetWindowPos( h_tab, lists[i].h_wnd,
                    0, 0, 0, 0,
                    SWP_NOMOVE | SWP_NOSIZE
                    );
    }
    // BmsRegistArraỹXgƌт
    lists[0].bms = bms->get_wavs();
    lists[1].bms = bms->get_bmps();
    // EBhE^CgύX
    set_window_title( h_wnd );

    // tHg쐬Ao^
    HFONT h_font = CreateFont(
      12, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
      SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
      CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY ,
      FIXED_PITCH | FF_MODERN , NULL
      );
    SendMessage( group,        WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( label_title,  WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( edit_title,   WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( label_genre,  WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( edit_genre,   WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( label_artist, WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( edit_artist,  WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    SendMessage( h_tab,        WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    for ( int i = 0; i < LIST_COUNT; ++i ) {
      SendMessage( lists[i].h_wnd, WM_SETFONT, (WPARAM)h_font, (LPARAM)true );
    }

    input_control_content();

    return 0;
  }
  return DefWindowProc( h_wnd, msg, wp, lp );
}



// Xg̃vV[W̔h
static LRESULT CALLBACK list_wind_proc( HWND h_wnd, UINT msg, WPARAM wp, LPARAM lp ) {

  switch ( msg ) {
  case WM_SYSKEYDOWN:
    switch ( wp ) {
    case VK_UP: // ALT + UP
      move_list( h_wnd, current_list.bms, false, current_list.h_wnd == lists[0].h_wnd ? move_bms_list_wav : move_bms_list_bmp );
      return 0;

    case VK_DOWN: // ALT + DOWN
      move_list( h_wnd, current_list.bms, true, current_list.h_wnd == lists[0].h_wnd ? move_bms_list_wav : move_bms_list_bmp );
      return 0;

    case VK_LEFT:
      input_control_content();
      return 0;

    }
    break;

  case WM_KEYDOWN:
    switch ( wp ) {
    case VK_DELETE: // DELETEL[
      int cursel_point;
      cursel_point = SendMessage( current_list.h_wnd, LB_GETCURSEL, 0, 0 );

      for ( int i = 0; i < BMS_OBJ_MAX; i++ ) {
        if ( SendMessage( current_list.h_wnd, LB_GETSEL, i, 0 ) ) {
          current_list.bms->delete_at( BmsWord( i ) );
          repaint_list( current_list.h_wnd, i, "" );
        }
      }
      SendMessage( current_list.h_wnd, LB_SETSEL, TRUE, cursel_point );
      return 0;

    case VK_RETURN:
      if ( h_wnd != lists[0].h_wnd ) { return 0; }
      char wav_filename[MAX_PATH];
      strcpy( wav_filename, bms_dir );
      strcat( wav_filename, lists[0].bms->at( SendMessage( h_wnd, LB_GETCURSEL, 0, 0 ) ) );
      PlaySound( wav_filename, NULL, SND_FILENAME | SND_ASYNC | SND_NODEFAULT );
      return 0;
    }
    break;

  case WM_DROPFILES: // t@CD&D
    HDROP h_drop; h_drop = (HDROP)wp;

    UINT drop_num; drop_num = DragQueryFile( h_drop, 0xFFFFFFFF, NULL, 0 );

    int input_point; input_point = SendMessage( current_list.h_wnd, LB_GETCURSEL, 0, 0 );
    // ݈ʒȗIOĂ
    SendMessage( current_list.h_wnd, LB_SETSEL, FALSE, input_point );

    for ( int i = 0; i < (int)drop_num; ++i ) {
      // }ꏊ
      while ( current_list.bms->is_exist( input_point ) ) {
        ++input_point;
        if ( input_point >= BMS_OBJ_MAX ) { break; }
      }
      // Ă
      if ( input_point >= BMS_OBJ_MAX ) { --input_point; break; }

      // D&Dt@C̃pX菜
      char filename[MAX_PATH];
      DragQueryFile( h_drop, i, filename, sizeof(filename) );
      edit_basename( filename );

      // Xg{bNXɓo^
      repaint_list( current_list.h_wnd, input_point, filename );

      // f[^ɓo^
      current_list.bms->overwrite( BmsWord( input_point ), filename );
    }
    // ŌIĂ
    SendMessage( current_list.h_wnd, LB_SETSEL, TRUE, input_point );
    DragFinish( h_drop );
    SetForegroundWindow( h_wnd );
    return 0;

  }
  return CallWindowProc( list_wind_proc_super, h_wnd, msg, wp, lp );
}


// Xg̈ړ up͌̕ǂ
bool move_list( HWND h_wnd, BmsRegistArray *list, bool up, void (*move_list_func)( int, int, bool ) ) {
  // "00"w肳Ă牽Ȃ
  if ( SendMessage( h_wnd, LB_GETSEL, 0, 0 ) ) { return false; }

  int start = up ? 1 : BMS_OBJ_MAX - 1;
  int end   = up ? BMS_OBJ_MAX - 1 : 1;
  int direction = up ? 1 : -1;

  // ʒu̍Ōオw肳Ă炻ȏ͍sȂ
  if ( SendMessage( h_wnd, LB_GETSEL, end, 0 ) ) { return false; }
  else {

    bool on_select = false;
    int select_start = start + direction;
    for ( int i = start; i != end + direction; i += direction ) {
      if ( on_select ) {
        if ( SendMessage( h_wnd, LB_GETSEL, i, 0 ) && i != end ) { continue; }
        else {
          on_select = false;
          int move_start = up ? select_start : i - direction;
          int move_end   = up ? i - direction : select_start;

          (*move_list_func)( move_start, move_end, up );
          // ͈̔͂
          for ( int k = select_start; k != i + direction; k += direction ){
            repaint_list( current_list.h_wnd, k, list->at( BmsWord( k ) ) );
            // ړIȂꏊ
            if ( k != select_start ) { SendMessage( current_list.h_wnd, LB_SETSEL, TRUE, k ); }
          }
        }
      }
      else {
        if ( SendMessage( h_wnd, LB_GETSEL, i, 0 ) ) {
          on_select = true;
          select_start = i;
        }
      }
    }
  }
  return true;
}



// bmsRg[e
static void input_control_content( void ) {

  BmsHeaderHash *headers = bms->get_headers();

  SetWindowText( edit_title, headers->fetch_str( LABEL_TITLE_STR ) );
  SetWindowText( edit_genre, headers->fetch_str( LABEL_GENRE_STR ) );
  SetWindowText( edit_artist, headers->fetch_str( LABEL_ARTIST_STR ) );

  LockWindowUpdate( current_list.h_wnd );
  for ( int i = 0; i < LIST_COUNT; i++ ) {
    SendMessage( lists[i].h_wnd, LB_RESETCONTENT, 0, 0 );
  }
  for ( int i = 0; i < BMS_OBJ_MAX; i++ ) {
    char buf[1024];
    BmsWord( i ).get_str( buf );
    buf[2] = ':';
    const char *wav_str = bms->get_wavs()->at( BmsWord( i ) );
    strcpy( &buf[3], wav_str );
    SendMessage( lists[0].h_wnd, LB_ADDSTRING, i, (LPARAM)buf );

    const char *bmp_str = bms->get_bmps()->at( BmsWord( i ) );
    strcpy( &buf[3], bmp_str );
    SendMessage( lists[1].h_wnd, LB_ADDSTRING, i, (LPARAM)buf );
  }

  LockWindowUpdate( NULL );
}


// Jt@C擾
static bool get_open_filename( HWND h_wnd ) {
  OPENFILENAME ofn;
  memset( &ofn, 0, sizeof( OPENFILENAME ) );
  ofn.lStructSize     = sizeof( OPENFILENAME );
  ofn.hwndOwner       = h_wnd;
  ofn.lpstrFilter     = "BMSt@C(*.bms;*.bme)\0*.bms;*.bme\0\0";
  ofn.nFilterIndex    = 1;
  ofn.lpstrFile       = bms_path;
  ofn.nMaxFile        = MAX_PATH;
  ofn.lpstrFileTitle  = NULL;
  ofn.nMaxFileTitle   = 0;
  char last_open_dir_buf[MAX_PATH];
  GetPrivateProfileString( INI_SECTION_FILE, INI_LAST_OPEN_DIR, bms_dir, last_open_dir_buf, MAX_PATH, ini_filename );
  ofn.lpstrInitialDir = last_open_dir_buf;
  ofn.lpstrTitle      = "BMSt@CJ";
  ofn.Flags           = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
  ofn.FlagsEx         = OFN_EX_NOPLACESBAR;
  if ( !GetOpenFileName( &ofn ) ) { return false; }
  return true;
}



// ۑt@C擾
static bool get_save_filename( HWND h_wnd ) {
  OPENFILENAME ofn;
  memset( &ofn, 0, sizeof( OPENFILENAME ) );
  ofn.lStructSize     = sizeof( OPENFILENAME );
  ofn.hwndOwner       = h_wnd;
  ofn.lpstrFilter     = "BMSt@C(*.bms;*.bme)\0*.bms;*.bme\0\0";
  ofn.nFilterIndex    = 1;
  ofn.lpstrFile       = bms_path;
  ofn.nMaxFile        = MAX_PATH;
  ofn.lpstrFileTitle  = NULL;
  ofn.nMaxFileTitle   = 0;
  char last_open_dir_buf[MAX_PATH];
  GetPrivateProfileString( INI_SECTION_FILE, INI_LAST_OPEN_DIR, bms_dir, last_open_dir_buf, MAX_PATH, ini_filename );
  ofn.lpstrInitialDir = last_open_dir_buf;
  ofn.lpstrTitle      = "BMSt@Cۑ";
  ofn.Flags           = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
  ofn.FlagsEx         = OFN_EX_NOPLACESBAR;
  if ( !GetSaveFileName( &ofn ) ) { return false; }
  return true;
}



// init@Cɐݒۑ
static bool save_ini( HWND h_wnd ) {
  RECT rect;
  GetWindowRect( h_wnd, &rect );

  char buf[1024];
  wsprintf( buf, "%s=%d%c%s=%d%c%s=%d%c%s=%d%c",
            INI_POINT_X, rect.left,   '\0',
            INI_POINT_Y, rect.top,    '\0',
            INI_WIDTH,   rect.right - rect.left, '\0',
            INI_HEIGHT,  rect.bottom - rect.top, '\0' );
  WritePrivateProfileSection( INI_SECTION_WINDOW, buf, ini_filename );

  return true;
}
